

clear;
close all;

delta_TE=1.02e-3;  % s

% B0 & ROI
fname_roi=select_file('*.nii','.','SELECT ROI NIFTI');
fname_b0=select_file('*.nii','.','SELECT B0 NIFTI');

roi_nii=load_nifti(fname_roi);
b0_nii=load_nifti(fname_b0);

% TEST
% load roi_manualEdit;

roi=permute( roi_nii.vol(:,:,1,1),[2 1] );
roi=roi > max(roi(:))/15;
f0=figure; imagesc(roi); axis image off; colorbar; % title('Field map (Hz), Meas.','FontSize',12);
set(gca,'FontSize',15);
print(f0,'-djpeg','-r300','roi.jpg');
save 'roi.mat' 'roi';

roi_orig=roi;

roi2=roipoly();
roi=roi & roi2;
f1=figure; imagesc(roi); axis image off; colorbar; % title('Field map (Hz), Meas.','FontSize',12);
set(gca,'FontSize',15);
print(f1,'-djpeg','-r300','roi_manualEdit.jpg');
save 'roi_manualEdit.mat' 'roi';

b0map=( permute( b0_nii.vol,[2 1] )/4096*2*pi - pi )/(2*pi*delta_TE) .* roi_orig;
f2=figure; imagesc(b0map); axis image off; colorbar; caxis([-100 100]); % title('Field map (Hz), Meas.','FontSize',12);
set(gca,'FontSize',15);
print(f2,'-djpeg','-r300','B0.jpg');
save 'b0map.mat' 'b0map';

% B1+ & SODA
fname=select_file('*fld','.','SELECT FLD FILE');
[header B1 B0 mask SODA]=read_fld_file(fname);

nx=SODA.ncols;
ny=SODA.nrows;

b1maps=reshape( B1.data,nx,ny,1,header.ncoils ); %  .* repmat(roi,[1 1 1 header.ncoils]);
b1maps=permute( b1maps,[2 1 3 4] );  % niftii = transpose of DICOM
b1maps=b1maps.*repmat(roi_orig,[1 1 1 8]);
save 'b1maps.mat' 'b1maps';

SODA.cols_pos=[0:SODA.ncols-1]'*SODA.VoxelWidth + SODA.UpperLeftCornerImage(1);  % this x in the Dicom convention (left to right)
SODA.rows_pos=[0:SODA.nrows-1]'*SODA.VoxelHeight + SODA.UpperLeftCornerImage(2);  % this y in the Dicom convention (uo to down)
save 'SODA.mat' 'SODA';    

to_disp=[ b1maps(:,:,1,1) b1maps(:,:,1,2) b1maps(:,:,1,3);
    b1maps(:,:,1,4) b1maps(:,:,1,5) b1maps(:,:,1,6);
    b1maps(:,:,1,7) b1maps(:,:,1,8) zeros(size(b1maps(:,:,1,3))) ];

f3=figure; imagesc(abs(to_disp)); axis image; axis off; colormap(hot); colorbar;
set(gca,'FontSize',15);
print(f3,'-djpeg','-r300','B1_mag.jpg');
title('B1 maps [T/V]','FontSize',12);

f4=figure; imagesc(angle(to_disp)); axis image; axis off; colormap(hot); colorbar;
set(gca,'FontSize',15);
print(f4,'-djpeg','-r300','B1_pha.jpg');
title('B1 maps [rad.]','FontSize',12);








